#!/bin/sh

CONF="$1"
DIRNAME=`dirname "$0"`/..

if [ ! "$CONF" ] || [ "$CONF" = '--help' ]; then
    cat 1>&2 <<EOF
Usage: $0 <configuration>

Apply patch files for the configuration to the repository.
EOF
    exit 1
fi

if [ ! -e "$DIRNAME/FILES-$CONF.txt" ]; then
    cat 1>&2 <<EOF
Configuration not recognised: $CONF

Try one of the following:

EOF
    for FILENAME in "$DIRNAME/FILES-"*.txt ; do
      echo `basename "$FILENAME" .txt | sed 's/^FILES-//'`
    done
    exit 1
fi

# Patch files appropriate to the configuration.

grep -e '.diff$' "$DIRNAME/FILES-$CONF.txt" | xargs -I{} sh -c "patch -p0 < \"$DIRNAME/{}\""

# Make sure that all files are added.

grep -e '.diff$' "$DIRNAME/FILES-$CONF.txt" | xargs -I{} grep ^Index "$DIRNAME/{}" | cut -d ' ' -f 2 | xargs -I{} svn add --parents '{}'
