#!/bin/sh

CONF="$1"
REVISION="$2"
DIRNAME=`dirname "$0"`/..

if [ ! "$CONF" ] || [ "$CONF" = '--help' ]; then
    cat 1>&2 <<EOF
Usage: $0 <configuration> [ <revision> ]

Restore files patched for the configuration in the repository.
EOF
    exit 1
fi

# Remove patched files, making tracked files missing.

cat "$DIRNAME/FILES-$CONF.txt" | xargs -I{} grep ^Index "$DIRNAME/{}" | cut -d ' ' -f 2 | xargs rm

# Delete empty directories.

for DIR in `find . -name .svn -prune -o -type d` ; do
    for FILENAME in "$DIR/"* ; do
        if [ "$FILENAME" = "$DIR/*" ]; then
            rmdir "$DIR"
	else
            break
        fi
    done
done

# Make sure that all patched files are reverted.

svn update "$REVISION"
svn revert -R .
